/**
 * @file strategySelector.h
 *
 * @author Jan Hadrava
 * @date 2004
 * @ingroup iopclibcache
 */


#ifndef STRATEGYSELECTOR_H_
#define STRATEGYSELECTOR_H_

// project: POLiTe
// authors: Jan Hadrava 2004

#include "strategy.h"
#include "../persIdentification.h"

namespace iopc {

/**
 * @brief A strategy selector class
 *
 * @ingroup iopclibcache
 */
class DLL_EXTERNAL StrategySelector {
public:
	inline StrategySelector();
	inline StrategySelector(const Strategy& defaultStrategy);
	inline virtual ~StrategySelector();
	inline virtual const Strategy& select() const;
	inline virtual const Strategy& select(const PersIdentification& persId) const;
protected:
	Strategy defaultStrategy;
};

inline StrategySelector::StrategySelector()
: defaultStrategy()
{
}

inline StrategySelector::StrategySelector(const Strategy& defaultStrategy)
: defaultStrategy(defaultStrategy)
{
}

inline StrategySelector::~StrategySelector()
{
}

inline const Strategy& StrategySelector::select() const
{
	return defaultStrategy;	/* return default strategy */
}

inline const Strategy& StrategySelector::select(const PersIdentification& persId) const
{
	return defaultStrategy;	/* return default strategy */
}

}/*namespace iopc*/

#endif /*STRATEGYSELECTOR_H_*/
