/**
 * @file typeRegistrar.h
 *
 * @ingroup iopcmeta
 *
 * @author Petr Cermak
 */

#ifndef TYPEREGISTRAR_H_
#define TYPEREGISTRAR_H_

#include "typeManager.h"
#include "typeDesc.h"

namespace iopc {

/**
 * @brief Registers a type at the @a TypeManager
 *
 * Static instances of this class specializations are generated by @c iopcsp in the IC files.
 *
 * @ingroup iopcmeta
 */
template <typename T>
class TypeRegistrar
{
public:
TypeRegistrar()
{
	TypeManager::registerType(&(TypeDesc<T>::getType()), &typeid(T));
}
};

}

#endif /*TYPEREGISTRAR_H_*/
