/**
 * @file simpleQuery.cpp
 *
 * @author Petr Cermak
 *
 * @ingroup iopclib
 */

#include "simpleQuery.h"
#include "iopcmeta/type.h"
#include "types/dbTypeManager.h"
#include "iopcdb/driver.h"
#include "db/mappingStatementsFeature.h"

using namespace std;
using namespace iopc;


string SimpleQuery::getSql(Driver& drv, const Type& type) const
{

	DbType& dbType = DbTypeManager::getDbType(type);
	MappingStatementsFeature& msf = drv.getFeature<MappingStatementsFeature>();
	MetadataHolder attributes;
	if (all) {
		attributes["db.query.predef.all"].setBoolValue(true);
	} else {
		string substituted = substituteQuery(query, type);
		attributes["db.query.where"].setStringValue(substituted);
	}
	if (sort != "") {
		string substituted = substituteQuery(sort, type);
		attributes["db.query.orderBy"].setStringValue(substituted);
	}

	return msf.getQueryStatement(dbType, attributes);
}


Query* SimpleQuery::clone() const
{
	return new SimpleQuery(*this);
}

SimpleQuery SimpleQuery::All;
