/**
 * @file cacheSelector.h
 *
 * @author Jan Hadrava
 * @date 2004
 * @ingroup iopclibcache
 */


#ifndef CACHESELECTOR_H_
#define CACHESELECTOR_H_

// project: POLiTe
// authors: Jan Hadrava 2004


#include "cache.h"
#include "extendedCache.h"
#include "iopccommon/defs.h"
#include "../persIdentification.h"

namespace iopc {

/** Abstract interface for accessing services provided by cache selectors.
* Cache selector associates caches with object IDs.
*
* @ingroup iopclibcache
* */
class DLL_EXTERNAL CacheSelector {
public:
	/**< Return first cache. Used when traversing all caches contained in selector. */
	virtual ExtendedCache* firstCache() = 0;
	/**< Traverses through caches contained in selector. */
	virtual ExtendedCache* nextCache() = 0;
	/**< Returns cache associated with object ID. */
	virtual ExtendedCache* selectCache(const PersIdentification& persId) = 0;

	inline virtual ~CacheSelector() {}
};

}/*namespace iopc*/


#endif /*CACHESELECTOR_H_*/
