#include "iopccommon/trace.h"
#include "tests/dbPtrTest.h"
#include "iopclib/dbPtr.h"
#include "iopcdb/driverManager.h"
#include "iopclib/db/cachedDatabase.h"
#include "iopclib/db/cachedConnection.h"
#include "iopclib/cache/voidCache.h"
#include "testSchema/diamond.h"

//#include "testSchema/fakeObject.h"
//#include "testSchema/fakeType.h"

using namespace iopc;
using namespace std;

DbPtrTest::DbPtrTest(const std::string& testName)
 : TestCase(testName)
{

}

DbPtrTest::~DbPtrTest()
{
}


bool DbPtrTest::doTest()
{
	Database* db = NULL;
	CachedConnection* conn = NULL;
	bool ret = true;
	try {
		db = new CachedDatabase(DriverManager::getDriver("IopcOracle10g").getDatabase(DBNAME), new VoidCache());
		conn = (CachedConnection*)db->getConnection(CONNSTR);
		conn->open();

		DbPtr<DiamondClass> objectPtr;
		objectPtr->test();

		objectPtr.bePersistent(conn);

//		objectPtr->test();

		DbPtr<DiamondClass> ptr2 = objectPtr;
//		ptr2->test();
		try {
			ptr2.bePersistent(conn);
			ret = false;
		} catch (IopcInvalidStateException& e) {
			ret = true;
		}
		//logMsg("Out of order!!");

	} catch (IopcException& e) {
		LogWriter::logError(e.what());
		ret = false;
	}

	if (db && conn) db->returnConnection(conn);
	if (db) DriverManager::getDriver("IopcOracle10g").returnDatabase(db);

	return ret;
}

static DbPtrTest dbPtrTestInstance("DbPtr Test");
